#include "ti86asm.inc"

;----- my variables
#define	sram	_textShadow	;savesscreen
cur_vat			= sram
prog_start		= sram+2
cursorx			= sram+4
cursory			= sram+5
maposx			= sram+6
maposy			= sram+7
moves_leftvar		= sram+8
loaded_level		= sram+10
load_the_level		= sram+11
unlimited_moves		= sram+12	; 0 = no, 1 = yes
number_of_levels	= sram+14
CurPointer			= sram+15
CurString			= sram+17
var1	= sram+18
var2	= sram+19
byte_sized		= sram+20		;100	; 5 bytes for a level

   .org    _asm_exec_ram

	nop
	jp initialize
.dw $0000
.dw Title

Title:
	.db "Blink - TCPA",0

initialize:
	res 1,(iy+$0D)
	xor a
	ld (_undelBufLen),a
	ld de,$0801
	ld hl,_undelBuf
	call Search
	ld a,(NumStrings)
	or a
	ret z
	ld hl,_undelBuf
	ld (CurPointer),hl
	ld a,1
	ld (CurString),a

ActualBeginning:
	call _flushallmenus
	call _runindicoff
	call _clrLCD

	call DisplayLevel

	ld hl,$FC82
	ld a,%11111111
	ld b,12
LineLoop:
	ld (hl),a
	inc hl
	djnz LineLoop

	ld de,$0500				;0300h
	ld (_curRow),de
	ld hl,title
	call _puts
	ld de,32*256+22-16
	call text
	ld de,42*256+15-16
	call text
	ld de,41*256+57-16
	call text
	ld hl,level_txt
	ld de,41*256+87-16
	call text
	ld de,41*256+125-16			;27
	ld (_penCol),de
	xor a
	ld (unlimited_moves),a
	ld	(load_the_level),a
	inc a

	call DispA

	ld hl,press_2nd
	ld de,51*256+48-16
	call text
	ld de,11*256+33-16
	call text
	ld de,18*256+21-16
	call text	

initial_keypress:
	call _getky
	cp K_RIGHT
	jp z,load_lp
	cp K_LEFT
	jp z,new_lp
	cp K_EXIT
	jp z,ExitRoutine
	cp K_ALPHA
	jp z, level_select	
	cp K_DEL
	jp z,next_levelset
	cp K_SECOND
	jr nz,initial_keypress
	call _clrLCD
	ld a,(load_the_level)
	or a
	jr nz,load_level
	xor a
	ld (level),a

load_level:
	xor a
	ld (var1),a
	ld hl,$0000
	ld (maposx),hl
	ld hl,10*256+10
	ld (cursorx),hl
	ld hl,_plotSScreen
	ld de,_plotSScreen+1
	ld bc,1023
	ld (hl),0
	ldir
	ld h,1
	ld bc,16*256+8
	ld de,16*256+55
	call _ILine
	ld de,63*256+8
	call _ILine
	ld bc,63*256+55
	call _ILine
	ld de,16*256+55
	call _ILine
	ld de,58*256+60
	call _ILine
	ld bc,11*256+60
	ld de,16*256+55
	call _ILine
	ld de,58*256+60
	call _ILine
	ld de,11*256+13
	ld bc,11*256+60
	call _ILine
	ld bc,16*256+8
	call _ILine
	ld bc,71*256+2
	ld de,71*256+62
	call _ILine
	ld de,112*256+2
	call _ILine
	ld bc,112*256+62
	call _ILine
	ld hl,level_txt
	ld de,14*256+58
	call text
	ld de,24*256+58
	call text
	ld de,31*256+64
	call text
	ld hl,blink
	ld de,$FC10+9-11
	ld b,9
	call draw_lp
	ld hl,tcpa
	ld de,$FEC0+9-11
	ld b,17
	call draw_lp
	call xor_cursor
	ld hl,14*256+97			;81
	ld (_penCol),hl	
	ld a,(level)
	inc a
	call DispA

	call decomp

	ld a,25
	ld (moves_leftvar),a
	ld de,31*256+98			;80
	ld (_penCol),de
	call DispA
	jr keypress


decomp:
	ld hl,byte_sized
	ld de,byte_sized+1
	ld bc,24
	ld (hl),0
	ldir
	ld hl,$8600-1
	ld a,(level)
	ld b,a
	add a,a
	add a,a
	add a,b	
	ld d,0
	ld e,a
	add hl,de
	ld de,byte_sized
	ld b,5
decompress:
	inc hl	
	ld a,(hl)
	push bc
	ld b,5
decomp_djnz:
	rla
	push af
	call c,set_byte
	call nc,res_byte
	pop af
	inc de
	djnz decomp_djnz
	pop bc
	djnz decompress

tile_map:
	ld de,byte_sized
	ld hl,10*256+10
tile_lp:
	ld ix,off
	ld a,(de)
	or a
	call nz,tile_map_loop_on
	ld b,8
	ld a,h
	push de
	push hl
	call PutSprite
	pop hl
	pop de
	inc de
	ld a,h
	add a,9
	cp 55
	ld h,a
	jr nz,tile_lp
	ld h,10
	ld a,l
	add a,9
	ld l,a
	cp 55
	jr nz,tile_lp

tile_map_loop_on:
	ld ix,on			; load ix with on
	ret

keypress:
	call xor_cursor
	call _getky
	push af
	cp K_RIGHT
	call z,cursor_right
	pop af
	push af
	cp K_LEFT
	call z,cursor_left
	pop af
	push af
	cp K_UP
	call z,cursor_up
	pop af
	push af
	cp K_DOWN
	call z,cursor_down
noarrows:
	pop af
	cp K_SECOND
	jr z,second_pressed
	cp K_MORE
	jp z, restart_level
	push af
	cp K_DEL
	jr nz,dummer
	ld a,(unlimited_moves)
	xor 1
	ld (unlimited_moves),a
dummer:
	pop af
	cp K_EXIT
	jp z,exit
	jr keypress

second_pressed:
	call tile_map
	call update_row
	call update_movesleft
	jp check_win

update_row:
	ld hl,byte_sized-1
	ld a,(maposx)
	or a
	jr z,skip_dec
	dec a
skip_dec:
	ld e,a
	ld d,0
	add hl,de
	ld a,(maposy)
	ld b,a
	add a,a
	add a,a
	add a,b
	ld e,a
	ld d,0
	add hl,de
	ld b,3
	ld a,(maposx)
	cp 4
	jr nz,smth
	ld b,2
smth:
	or a
	jr nz,row_update_lp
	ld b,2
row_update_lp:
	inc hl
	ld a,(hl)
	xor 1
	ld (hl),a
	djnz row_update_lp

update_up:
	ld hl,byte_sized
	ld a,(maposx)
	ld e,a
	ld d,0
	add hl,de
	ld a,(maposy)
	or a
	jr z,update_down
	dec a
	ld b,a
	add a,a
	add a,a
	add a,b
	ld e,a
	ld d,0
	add hl,de
	ld a,(hl)
	xor 1
	ld (hl),a
	
update_down:
	ld hl,byte_sized
	ld a,(maposx)
	ld e,a
	ld d,0
	add hl,de
	ld a,(maposy)
	cp 4
	jp z,tile_map
	inc a
	ld b,a
	add a,a
	add a,a
	add a,b
	ld e,a
	ld d,0
	add hl,de	
	ld a,(hl)
	xor 1
	ld (hl),a
	call tile_map
	ret

cursor_right:
	ld a,(cursorx)
	cp 46
	ret z
	push af
	ld a,(var1)
	or a
	call nz,xor_cursor
	pop af
	add a,9
	ld (cursorx),a
	ld a,(maposx)
	inc a
	ld (maposx),a
	jp xor_cursor

cursor_left:
	ld a,(cursorx)
	cp 10
	ret z
	push af
	ld a,(var1)
	or a
	call nz,xor_cursor
	pop af
	sub 9
	ld (cursorx),a
	ld a,(maposx)
	dec a
	ld (maposx),a
	jp xor_cursor

cursor_up:
	ld a,(cursory)
	cp 10
	ret z
	push af
	ld a,(var1)
	or a
	call nz,xor_cursor
	pop af
	sub 9
	ld (cursory),a
	ld a,(maposy)
	dec a
	ld (maposy),a
	jp xor_cursor

cursor_down:
	ld a,(cursory)
	cp 46
	ret z
	push af
	ld a,(var1)
	or a
	call nz,xor_cursor
	pop af
	add a,9
	ld (cursory),a
	ld a,(maposy)
	inc a
	ld (maposy),a
	jp xor_cursor

xor_cursor:
	ld b,8
	ld ix,cursor
	ld a,(cursory)
	ld l,a
	ld a,(cursorx)
	call PutSprite
	ld a,(var1)
	xor 1
	ld (var1),a
	ret

draw_lp:
	push hl
	ld hl,11
	add hl,de
	ex de,hl
	pop hl
	push bc
	ld bc,5
	ldir
	pop bc
	djnz draw_lp
	ret

exit:
	call BackupScreen
	ld hl,are_you_sure
	ld de,1*256+10
	set textInverse, (iy+textflags)
	call text
	ld de,8*256+28
	call text
	res textInverse, (iy+textflags)
	ld de,8*256+48
	call text
	ld e,0
exit_lp1:
	push de
exit_lp:
	call _getky
	cp K_RIGHT
	jr z,move_cursor_right
	cp K_LEFT
	jr z,move_cursor_left
	cp K_SECOND
	jr z,pick_cursor	
	jr exit_lp

move_cursor_right:
	pop de
	ld a,e
	or a
	jr nz,exit_lp1
	ld hl,yes
	ld de,8*256+28
	call text
	ld de,8*256+48
	set textInverse, (iy+textflags)
	call text
	res textInverse, (iy+textflags)
	ld e,1
	jr exit_lp1

move_cursor_left:
	pop de
	ld a,e
	or a
	jr z,exit_lp1
	ld hl,yes
	ld de,8*256+28
	set textInverse, (iy+textflags)
	call text
	res textInverse, (iy+textflags)
	ld de,8*256+48
	call text
	ld e,0
	jr exit_lp1

pick_cursor:
	pop de
	ld a,e
	or a
	jp z,ActualBeginning
	call RestoreScreen
	jp keypress

check_win:
	xor a
	inc a
	ld bc,25
	ld hl,byte_sized
	cpir
	jp z,check_movesleft
	call tile_map
	ld a,(number_of_levels)
	ld b,a
	ld a,(level)
	inc a
	cp b
	jp z, you_have_won
	ld (level),a
	ld de,14*256+97			;81
	ld (_penCol),de
	ld a,(level)	
	inc a
	call DispA
	ld a,(var1)
	or a
	call nz,xor_cursor
	jp load_level

load_lp:
	xor a
	inc a
	ld (load_the_level),a
	ld de,41*256+125-16			;27
	ld (_penCol),de
	ld a,(level)
	inc a
	call DispA
	ld de,41*256+57-16
	ld hl,load
	call text
	jp initial_keypress

new_lp:
	ld de,41*256+125-16			;27
	ld (_penCol),de
	xor a
	ld (load_the_level),a
	inc a
	call DispA
	ld hl,new
	ld de,41*256+57-16
	call text
	jp initial_keypress

next_levelset:
	ld hl,$0A04
	ld (_curRow),hl
	ld hl,Empty
	call _puts
	ld a,(NumStrings)
	ld b,a
	ld a,(CurString)
	cp b
	jr nz,SkipReset
	xor a
SkipReset:
	inc a
	ld (CurString),a
	dec a
	ld b,a
	add a,a
	add a,b
	ld hl,_undelBuf
	ld d,0
	ld e,a
	add hl,de
	ld (CurPointer),hl
	call DisplayLevel
	jp initial_keypress

too_many_moves:
	call BackupScreen
	ld hl,manymoves
	ld de,1*256+5
	set textInverse, (iy+textflags)
	call text
	res textInverse, (iy+textflags)

idle_loop:
	call _getkey
	call RestoreScreen
restart_level:
	call tile_map
	ld a,(var1)
	or a
	call nz,xor_cursor
	jp load_level


BackupScreen:
	ld hl,$FC00
	ld de,$8200
	ld bc,1024
	ldir
	ret

RestoreScreen:
	ld de,$FC00
	ld hl,$8200
	ld bc,1024
	ldir
	ret


level_select:
	call _getky
	cp K_UP
	jr nz,onemorelabel
	ld a,(number_of_levels)
	ld b,a
	ld a,(level)
	inc a
	cp b	
	jr z,level_select
	ld (level),a
	ld de,41*256+125-16		;27
	ld (_penCol),de
	inc a
	call DispA
onemorelabel:
	cp K_DOWN
	jr nz,twomorelabel
	ld a,(level)
	or a
	jr z,level_select
	dec a
	ld (level),a
	ld de,41*256+125-16		;27
	ld (_penCol),de
	inc a
	call DispA
twomorelabel:
	cp K_SECOND
	jr nz, level_select
	call _clrLCD
	jp load_level

update_movesleft:
	ld a,(unlimited_moves)
	or a
	ret nz
	ld de,31*256+98			;80
	ld (_penCol),de
	ld a,(moves_leftvar)
	dec a
	ld (moves_leftvar),a
	call DispA
	ret
	
check_movesleft:
	ld a,(unlimited_moves)
	or a
	jr nz,minegen
	ld a,(moves_leftvar)
	or a
	jp z,too_many_moves
minegen:
	jp keypress

you_have_won:
	call _clrLCD
	ld de,$0500			;0300h
	ld (_curRow),de
	ld hl, congrats
	call _puts
	ld de,$0501			;0301h
	ld (_curRow),de
	ld hl,winner
	call _puts
	call _getkey
	jp ActualBeginning

text:
	ld a,16
	add a,e
	ld e,a
	ld (_penCol),de
	jp _vputs

set_byte:
	ld a,1
	ld (de),a
	ret
res_byte:
	xor a
	ld (de),a
	ret


DisplayLevel:
	ld de,32*256+56			;39
	ld (_penCol),de
	ld hl,(CurPointer)
	ld a,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld e,(hl)
	ex de,hl

	call _load_ram_ahl
	call _vputs
	ld a,(hl)
	inc hl
	ld (number_of_levels),a
	ld d,a
	add a,a	;*2
	add a,a	;*4
	add a,d	;*5
	ld c,a
	ld b,0
	push bc
	ld de,_plotSScreen
	ldir
	call _ram_page_1
	pop bc
	ld hl,_plotSScreen
	ld de,$8600
	ldir
	ret
	

DispA:                                  ;Routine to Display A [By: Matthew Shepcar]

	push af
	ld hl,Empty
	call _vputs
	ld a,(_penCol)
	sub 10
	ld (_penCol),a
	pop af

 ld l,a                                 ;Loads a into l
 ld h,0                                 ;0 into H
DispHL:                                 ;Displays HL [By: Matthew Shepcar]
 xor a                                  ;Loads 0 into A
 ld de,-1                               ;Loads -1 into DE
 ld (_curRow),de                        ;Loads de into CurRow
 call 4A33h                             ;Calls 4A33h
 dec hl                                 ;Decrease it
 jp _vputs                              ;Put on screen and return

ExitRoutine:
	ld hl,_asapvar
	rst 20h
	rst 10h
	ld a,b
	ld hl,level-_asm_exec_ram+4
	add hl,de
	adc a,0
	call _set_abs_dest_addr
	xor a
	ld hl,level
	call _set_abs_src_addr
	ld hl,1
	call _set_mm_num_bytes
	call _mm_ldir
	set 1,(iy+$0D)
	set graphdraw,(iy+graphflags)
	call _homeup
	jp _clrScrn

;==========================================================
; Search for Strings routine
; by Andreas Finne <a_finne@hotmail.com>
; date: 22 Jun 2000
;
; Size: 126 bytes
;
; Input:
; DE = word to search for (two bytes)
; HL = place were the table should be placed (Must be on RAM page 0)
;
; Output:
;  - NumStrings = number of strings
;  - A table containing ABS pointers to the start of data of every
;    string. The addresses are stored in AHL format. To use the
;    table, load A with the first value, H with the second
;    and L with the third.
;==========================================================

Search:
	ld (Label),hl		;Uses selfmodifying code. This basically results in 'ld ix,hl'
	ld a,d			;Load a with the first ID-byte
	ld (FirstByte),a	;Change the cp 0 to cp ID-byte
	ld a,e			;Same thing with second ID-byte
	ld (SecondByte),a
	xor a
	ld (NumStrings),a	;No strings yet
	ld ix,$0000		;Point ix to a place were the addresses of the strings are going to be stored

Label = $-2			;This points to the $0000 in the previous line

	call _ram_page_7	;This will load RAM page #7 in the area between $8000 and $BFFF
				;RAM page 7 contains the VAT (variable allocation table, or something like that)
				;Here are the addresses of all the variables on the calc stored.
				;It's written backwards so the first entry is at $BFFF.
	ld hl,$BFFF		;We want to start searching at the beginning (top/bottom) of the VAT.
	ld bc,($D298)		;$D298 contains the address to the end (bottom/top) of the VAT.
	inc bc
SearchMainLoop:
	and a			;Clear the carry flag
	sbc hl,bc		;Subtract the bottom from the top to check if we are done.
	jr c,DoneSearching	;If carry, we are done searching.
	push bc
	add hl,bc		;Add bc to hl so we have the same value as before in hl
SearchLoopA:
	ld a,(hl)			;Load the ID byte for the first entry in the VAT.
	cp $0C				;We are looking for strings. $0C is the ID byte for strings.
	jr z,Found			;We found a string.
SkipName:
	dec hl				;Skip ID byte.
	dec hl				;Skip ABS address
	dec hl				;
	dec hl				;
	dec hl				;Skip an unused byte (This is where shells store the folder number!)
	ld b,(hl)			;Load b with the length of the name.
	inc b
SkipNameLoop:
	dec hl				;Skip the name.
	djnz SkipNameLoop		;After this hl points to the next ID byte.
	pop bc				;Get the end of the VAT back
	jr SearchMainLoop		;Goto beginning (almost).

Found:					;When we've come this far we have found a string. Now we're going to check
					;if it's one of our strings.
	push hl				;First we save the values so we can continue to search where we left off.
	dec hl				;hl points to ID byte, dec it so it points to the LSB of the ABS address.
	ld e,(hl)			;Load the LSB of the ABS address to e
	dec hl				;hl now points to the middle byte in the address
	ld d,(hl)			;Load it into d
	dec hl				;hl points to MSB of the address
	ld a,(hl)			;Load it into a
					;Now we have the address in ade, but the rom routines use ahl so...
	ex de,hl			;exchange de and hl. AHL = address to the string variable

	call _ahl_plus_2_pg3		;Skip the sign bytes of the string (ahl=ahl+2)

	ld c,a				;Save a and hl since 'call _getb_ahl' destroys a and hl
	push hl

	call _getb_ahl			;ld a,(ahl) Gets byte at ahl into a

	cp 0				;Is it the first ID-byte?

FirstByte = $-1				;This points to the 0 in the previous line

	pop hl				;Get the AHL address back
	ld a,c
	jr nz,NotOurString		;If not, continue search
	call _inc_ptr_ahl		;inc AHL
	ld c,a
	push hl				;Save
	call _getb_ahl			;Get byte
	cp 0				;Is it the second ID-byte?

SecondByte = $-1			;This points to the 0 in the previous line

	ld a,c				;Restore
	pop hl
	jr nz,NotOurString		; If not - continue search
					;Yes, we have found one of our strings. Now we save the address to the data
	call _inc_ptr_ahl		;inc AHL so it points to the first data instead of the second ID-byte
	ld (ix),a			;Store the address to the string
	ld (ix+1),h
	ld (ix+2),l
	inc ix				;Make ix point to empty space.
	inc ix
	inc ix
	ld a,(NumStrings)		;Update the number of strings
	inc a
	ld (NumStrings),a
NotOurString:
	call _ram_page_7		;Load back RAM page 7
	pop hl				;Get current search place back
	jr SkipName			;Go back to skip the name of the current string
DoneSearching:
	jp _ram_page_1			;Change back to RAM page 1

NumStrings:
	.db 0

;-----> Draw a sprite
; Original by Movax
; Modified by Andreas Finne
; Now takes the same parameters as ionPutsprite
;
; b=size of sprite
; l=yc
; a=xc
; ix holds pointer

PutSprite:
		ld h,a
		ld a,b
		ld (label1),a
		ld (label2),a
		ld a,h
		add a,8
		ld e,l
       push    ix              ; Save sprite address

;   Calculate the address in graphbuf   

	ld      hl,0            ; Do y*12
	ld      d,0
	ex      de,hl
	add     hl,hl
	add     hl,hl
	add     hl,hl
	add     hl,hl

	ld      d,0             ; Do x/8
	ld      e,a
	srl     e
	srl     e
	srl     e
	add     hl,de

	ld      de,$FC00		;_plotSScreen
	add     hl,de           ; Add address to graphbuf

	ld      b,00000111b     ; Get the remainder of x/8
	and     b
	cp      0               ; Is this sprite aligned to 8*n,y?
	jr      z,ALIGN


;   Non aligned sprite blit starts here   

	pop     ix              ; ix->sprite
	ld      d,a             ; d=how many bits to shift each line

	ld      e,8             ; Line loop

label1 = $-1

LILOP:  ld      b,(ix+0)        ; Get sprite data

	ld      c,0             ; Shift loop
	push    de
SHLOP:  srl     b
	rr      c
	dec     d
	jr      nz,SHLOP
	pop     de

	ld      a,b             ; Write line to graphbuf
	xor     (hl)
	ld      (hl),a
	inc     hl
	ld      a,c
	xor     (hl)
	ld      (hl),a

	ld      bc,15           ; Calculate next line address
	add     hl,bc
	inc     ix              ; Inc spritepointer

	dec     e
	jr      nz,LILOP        ; Next line

	jr      DONE1


;   Aligned sprite blit starts here   

ALIGN:                          ; Blit an aligned sprite to graphbuf
	pop     de              ; de->sprite
	ld      b,8

label2 = $-1

ALOP1:  ld      a,(de)
	xor      (hl)            ; xor=erase/blit
	ld      (hl),a
	inc     de
	push    bc
	ld      bc,16
	add     hl,bc
	pop     bc
	djnz    ALOP1

DONE1:
	ret


level:		.db 0

title:		.db "Blink V 1.1",0
levelset:	.db "Level set:",0
new_load:	.db "New or load:",0
new:		.db " new ",0
load:		.db "load",0
level_txt:	.db "Level:",0
moves_left1:	.db "Moves",0
moves_left2:	.db "left:",0
are_you_sure:	.db " Sure you want to exit?",0	
yes:		.db " Yes ",0
no:		.db " No ",0
you_won:	.db "You won",0
press_2nd:	.db "2nd to play",0
credits:	.db "by Matthew Landry",0
creditsb:	.db "TI-86 port by Andreas Finne",0
manymoves:	.db "Sorry, too many moves",0
congrats:	.db "Congrats",0
winner:		.db "You Won!",0
Empty:	.db "          ",0

off:
	.db %11111111
	.db %10000001
	.db %10000001
	.db %10000001
	.db %10000001
	.db %10000001
	.db %10000001
	.db %11111111

on:
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111

cursor:
	.db %00000000
	.db %01111110
	.db %01111110
	.db %01111110
	.db %01111110
	.db %01111110
	.db %01111110
	.db %00000000


tcpa:
  .db %11111111,%11111111,%11111111,%11111111,%11111111
  .db %11111111,%11111111,%11111111,%11111100,%00000111
  .db %11111111,%11111111,%11111110,%00000011,%11111011
  .db %11111111,%11111110,%00000001,%11111111,%11111101
  .db %11111111,%11111111,%11111111,%11111111,%11111110
  .db %11100000,%00011000,%00111000,%00111100,%01111110
  .db %11100000,%00010000,%00011000,%00011100,%01111110
  .db %11111100,%11110011,%10011001,%10011001,%00111101
  .db %11100100,%11110011,%11111000,%00011001,%00111011
  .db %11011100,%11110011,%11111000,%00110000,%00010111
  .db %10111100,%11110011,%10011001,%11110000,%00011111
  .db %01111100,%11110000,%00011001,%11100111,%11001111
  .db %01111100,%11111000,%00111001,%11100111,%11001111
  .db %01111111,%11111111,%11111111,%11111111,%11111111
  .db %10111111,%11111111,%10000000,%11111111,%11111111
  .db %11011111,%11000000,%01111111,%11111111,%11111111
  .db %11100000,%00111111,%11111111,%11111111,%11111111

blink:
  .db %11111111,%11111111,%11111111,%11111111,%11111111
  .db %11100001,%11011111,%00000110,%01101110,%11110111
  .db %11010110,%10101110,%11011101,%01010111,%01101111
  .db %11110110,%11101111,%11011111,%00110111,%01011111
  .db %11101001,%11011111,%10111110,%11101110,%10111111
  .db %11110110,%11101111,%11011111,%01110111,%01011111
  .db %11110110,%11101101,%11011011,%01110111,%01101111
  .db %11100001,%11000011,%00000110,%00100010,%00100111
  .db %11111111,%11111111,%11111111,%11111111,%11111111


.end
END